## START: Set by rpmautospec
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global srcname pytest-bdd
%global forgeurl https://github.com/pytest-dev/%{srcname}
%global tag %{version}

Name:           python-%{srcname}
Version:        4.1.0
%forgemeta
Release:        %autorelease
Summary:        BDD library for the py.test runner

License:        MIT
URL:            https://%{srcname}.readthedocs.io/en/latest/
Source0:        %{forgesource}

# Downstream man page
Source1:        %{srcname}.1

BuildArch:      noarch
 
BuildRequires:  python3-devel
BuildRequires:  pyproject-rpm-macros

# Documentation
BuildRequires:  make
BuildRequires:  python3dist(sphinx)

# Extra testing dependencies
BuildRequires:  python3dist(pytest)

%global common_description %{expand:
pytest-bdd implements a subset of the Gherkin language to enable automating
project requirements testing and to facilitate behavioral driven development.

Unlike many other BDD tools, it does not require a separate runner and benefits
from the power and flexibility of pytest. It enables unifying unit and
functional tests, reduces the burden of continuous integration server
configuration and allows the reuse of test setups.

Pytest fixtures written for unit tests can be reused for setup and actions
mentioned in feature steps with dependency injection. This allows a true BDD
just-enough specification of the requirements without maintaining any context
object containing the side effects of Gherkin imperative declarations.}

%description %{common_description}


%package -n     python3-%{srcname}
Summary:        %{summary}

%description -n python3-%{srcname} %{common_description}


%package        doc
Summary:        Documentation for %{name}

%description    doc %{common_description}


%prep
%forgeautosetup
cp -p '%{SOURCE1}' .


%generate_buildrequires
%pyproject_buildrequires -r requirements-testing.txt


%build
%pyproject_wheel
PYTHONPATH="${PWD}" %make_build -C docs html SPHINXOPTS='%{?_smp_mflags}'
rm -vf docs/_build/html/.buildinfo


%install
%pyproject_install
%pyproject_save_files %(echo '%{srcname}' | tr - _)
install -t '%{buildroot}%{_mandir}/man1' -p -m 0644 -D %{srcname}.1


%check
%pytest


%files -n python3-%{srcname} -f %{pyproject_files}
%license LICENSE.txt
%{_bindir}/%{srcname}
%{_mandir}/man1/%{srcname}.1*


%files doc
%license LICENSE.txt
%doc AUTHORS.rst
%doc CHANGES.rst
%doc README.rst
%doc docs/_build/html


%changelog
* Tue Aug 03 2021 Benjamin A. Beasley <code@musicinmybrain.net> 4.1.0-1
- Initial package
